% deconv_DtD
function r = deconv_DtD(x)
% compute D1'.D1.x
n = size(x, 1);
dx = x(2:n,:) - x(1:n-1,:);   % dx <-- D1.x
t1 = zeros(size(x));
t1(2:n,:) = dx;
t1(1:n-1,:) = t1(1:n-1,:) - dx;  % t <-- D1'.D1.x

% compute D2'.D2.x
n = size(x, 2);
dx = x(:,2:n) - x(:,1:n-1);   % dx <-- D2.x
t2 = zeros(size(x));
t2(:,2:n) = dx;
t2(:,1:n-1) = t2(:,1:n-1) - dx;

r = t1 + t2;
%------------------------------------------------------------------------------
% Local Variables:
% mode: Matlab
% tab-width: 8
% fill-column: 78
% coding: utf-8
% End:
